
%% Test data for N.A.C.A. Model No. 26 Flying-Boat Hull
%% Sikorsky S-40
%%
%% Kinematic viscosity = 0.000014 ft^2/sec
%% Water density = 63.5 lb/ft^3
%% Water temperature = 52 degF
%%

%% Speed (ft/sec) Resistance (lb) Trimming moment (lb ft) Draft (in)
%% Note: a load of 40 lb corrsponds to C_Delta = 1.56 - far higher than
%%       a C-class 'boat seems to be able to achieve.

%%  Trim angle 2 deg
trim2load5 = [ 29.5   5.0  2  1.1 ;
               35.3   5.7  1  1.1 ;
               39.2   6.8  1  0.9 ;
               44.8   7.4  1  0.9 ;
               48.8   8.4  1  0.9 ;
               54.0  10.0  1  0.8 ];
trim2load10 = [ 30.0   7.3  5  1.5 ;
                35.3   8.8  4  1.3 ;
                39.5   9.6  3  1.2 ;
                44.3  10.6  3  1.1 ;
                48.8  11.0  3  1.1 ;
                49.5  11.5  3  1.1 ;
                53.6  12.8  3  1.1 ];
trim2load60 = [ 6.0   3.1   9  4.7 ;
                7.8   6.6  36  4.9 ];
trim2load80 = [ 5.9   3.7   7  5.3 ;
                7.7   8.7  42  5.6 ];
trim2load100 = [ 5.9   4.2   3  5.8 ;
                 7.7  10.3  45  6.2 ];
trim2load120 = [ 5.9   4.6  -3  6.3 ;
                 7.7  12.1  46  6.8 ];

%%  Trim angle 3 deg

trim3load5   = [ 20.7   2.5   3  1.4 ;
                 23.0   2.9   2  1.2 ;
                 23.2   3.0   4  1.2 ;
                 26.3   3.4   2  1.1 ;
                 31.4   4.1   2  1.0 ;
                 36.7   4.6   2  0.8 ;
                 37.4   4.9   1  0.9 ;
                 42.1   6.4   1  0.9 ;
                 46.7   6.9   1  0.9 ;
                 51.8   7.3   2  0.7 ;
                 56.0   8.2   2  0.6 ];
trim3load10  = [ 21.1   3.7   6  1.8 ;
                 23.2   4.4   5  1.5 ;
                 26.2   4.7   4  1.3 ;
                 31.4   6.0   5  1.2 ;
                 36.8   7.3   4  1.1 ;
                 37.3   6.7   2  1.1 ;
                 41.7   8.2   3  1.2 ;
                 46.3   8.6   2  1.0 ;
                 46.7   9.0   2  1.0 ;
                 51.9  10.5   4  0.9 ;
                 55.7  11.0   2  0.8 ];
trim3load20  = [ 17.1   4.3  11  2.4 ;
                 19.1   4.7  12  2.4 ;
                 20.8   5.4  11  2.3 ;
                 23.1   6.2  11  1.9 ;
                 26.0   6.8  11  1.9 ;
                 31.4   8.7  10  1.7 ;
                 36.9  10.1   8  1.5 ;
                 42.2  11.7   6  1.3 ;
                 46.6  12.5   6  1.2 ;
                 52.5  14.3   6  0.9 ;
                 56.0  16.6   6  1.1 ];
trim3load40  = [ 12.3   6.9  30  3.7 ;
                 13.9   8.0  42  3.6 ;
                 16.7   8.3  46  3.4 ;
                 17.0   7.9  40  3.3 ;
                 18.7   7.8  36  3.2 ;
                 20.8   8.5  30  2.8 ;
                 23.2   8.5  24  2.5 ;
                 26.2  10.0  23  2.3 ;
                 31.5  11.5  19  1.8 ;
                 36.9  13.8  19  1.9 ;
                 41.9  16.3  20  1.8 ;
                 46.2  17.6  18  1.4 ];

%%  Trim angle 5 deg

trim5load5   = [ 20.8   2.1   1  0.8 ;
                 22.8   2.0   1  0.8 ;
                 24.8   2.1   1  0.9 ;
                 30.6   3.7   1  0.9 ;
                 34.9   4.4   3  0.7 ;
                 40.2   5.9   3  0.7 ;
                 45.2   7.3   3  0.7 ;
                 50.5   9.0   3  0.7 ;
                 55.5   9.7   3  0.5 ];
trim5load10  = [ 20.9   3.0   1  1.2 ;
                 23.0   3.1   2  1.1 ;
                 24.9   3.2   2  1.1 ;
                 30.6   4.5   2  1.0 ;
                 34.5   5.3   3  0.9 ;
                 40.3   7.4   2  0.8 ;
                 42.0   8.0   3  1.0 ;
                 45.0   9.0   2  0.8 ;
                 50.6  10.3   3  0.8 ;
                 55.2  11.0   3  0.8 ];
trim5load20  = [ 16.7   3.8   5  1.8 ;
                 18.7   4.2   5  1.9 ;
                 20.9   4.5   4  1.7 ;
                 23.2   4.9   5  1.5 ;
                 24.9   4.9   4  1.6 ;
                 30.8   6.3   3  1.2 ;
                 35.8   7.7   3  1.1 ;
                 41.1   9.8   1  1.0 ;
                 42.0   9.6   2  1.1 ;
                 45.0  11.0   1  1.0 ;
                 50.2  12.5   3  1.0 ;
                 55.2  14.8   1  0.9 ];
trim5load40  = [ 12.3   6.3  10  3.2 ;
                 14.3   6.9  26  3.1 ;
                 16.2   7.1  26  2.8 ;
                 16.5   6.9  22  2.6 ;
                 18.3   6.6  16  2.4 ;
                 20.8   7.2  11  2.1 ;
                 22.7   7.4  12  1.9 ;
                 24.5   7.6  11  2.0 ;
                 30.3   8.8  11  1.7 ;
                 35.1  10.4   9  1.5 ;
                 40.1  12.5   7  1.4 ;
                 45.0  14.9   5  1.2 ;
                 45.2  14.5   5  1.3 ;
                 50.0  16.6   3  1.1 ];

%%  Trim angle 7 deg

trim7load5   = [ 21.2   2.7   1  0.9 ;
                 23.2   3.4   0  0.9 ;
                 26.0   4.3   0  0.8 ;
                 28.8   5.1   0  0.7 ;
                 34.4   7.2  -1  0.5 ;
                 40.0   9.2  -1  0.6 ;
                 45.2  11.0  -2  0.5 ;
                 49.5  11.9  -3  0.3 ;
                 54.5  13.6  -3  0.3 ];  
trim7load10  = [ 20.8   3.3   2  1.3 ;
                 23.2   3.9   1  1.1 ;
                 26.2   5.0   0  1.0 ;
                 28.8   6.0  -1  0.9 ;
                 34.6   8.1  -2  0.8 ;
                 39.8  10.5  -5  0.7 ;
                 44.2  12.0  -4  0.7 ;
                 49.8  13.9  -6  0.5 ;
                 54.3  16.1  -6  0.4 ];
trim7load20  = [ 17.2   3.9   2  1.8 ;
                 19.0   4.0   3  1.8 ;
                 21.2   4.5   2  1.7 ;
                 23.1   5.2   2  1.4 ;
                 26.2   6.4   0  1.4 ;
                 29.0   7.5   0  1.2 ;
                 34.7  10.4  -3  1.2 ;
                 40.6  12.7  -8  0.8 ;
                 44.8  14.4 -11  0.8 ;
                 50.0  16.6 -12  0.7 ;
                 54.2  19.2 -13  0.6 ];

%%  Trim angle 9 deg

trim9load20  = [ 16.8   4.8 -16  1.5 ;
                 18.8   5.5 -11  1.7 ;
                 20.8   6.1  -4  1.4 ;
                 22.7   6.8  -5  1.3 ;
                 25.7   8.0 -12  1.0 ;
                 %% Fake point to fix the interpolation:
                 50.0  25.0 -15  1.0 ;
                 ];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Non dimensional coefficients.
%%
%%   Load coefficient:
%%     C_Delta = Delta / (w*b^3)
%%   Resistance coefficient:
%%     C_R = R / (w*b^3)
%%   Trimming moment coefficient:
%%     C_M = M / (w*b^4)
%%   Speed coefficient:
%%     C_V = V / sqrt(g*b)
%% where
%%  Delta - load on water (lb)
%%  R     - resistance (lb)
%%  M     - trimming moment (lb ft) 
%%  w     - weight density of water (lb/ft^3) 
%%  b     - beam of hull (ft)
%%  V     - speed (ft/sec)
%%  g     - acceleration of gravity (ft/sec^2)
Load = [5 10 20 40 60 80 100 120];
w = 63.5;
g = 32.185039;
b = 0.74;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% C_M

%% Compute C_M for a standard set of C_V for different loads and trim angles
C_V = 0:1.0:10;
trim = 2:10;

%% Load 0.19 (5lb)
C_Mt2l5 = interp1([0; trim2load5(:,1)]./sqrt(g*b), [0; trim2load5(:,3)]./(w*b^4), C_V, extrap='extrap', method='pchip');
C_Mt3l5 = interp1([0; trim3load5(:,1)]./sqrt(g*b), [0; trim3load5(:,3)]./(w*b^4), C_V, extrap='extrap', method='pchip');
C_Mt5l5 = interp1([0; trim5load5(:,1)]./sqrt(g*b), [0; trim5load5(:,3)]./(w*b^4), C_V, extrap='extrap', method='pchip');
C_Mt7l5 = interp1([0; trim7load5(:,1)]./sqrt(g*b), [0; trim7load5(:,3)]./(w*b^4), C_V, extrap='extrap', method='pchip');

%% Load 0.39 (10lb)
C_Mt2l10 = interp1([0; trim2load10(:,1)]./sqrt(g*b), [0; trim2load10(:,3)]./(w*b^4), C_V, extrap='extrap', method='pchip');
C_Mt3l10 = interp1([0; trim3load10(:,1)]./sqrt(g*b), [0; trim3load10(:,3)]./(w*b^4), C_V, extrap='extrap', method='pchip');
C_Mt5l10 = interp1([0; trim5load10(:,1)]./sqrt(g*b), [0; trim5load10(:,3)]./(w*b^4), C_V, extrap='extrap', method='pchip');
C_Mt7l10 = interp1([0; trim7load10(:,1)]./sqrt(g*b), [0; trim7load10(:,3)]./(w*b^4), C_V, extrap='extrap', method='pchip');

%% Load 0.78 (20lb)
C_Mt2l20 = interp1([0; trim2load10(:,1)]./sqrt(g*b), [0; trim2load10(:,3)]./(w*b^4), C_V, extrap='extrap', method='pchip');
C_Mt3l20 = interp1([0; trim3load20(:,1)]./sqrt(g*b), [0; trim3load20(:,3)]./(w*b^4), C_V, extrap='extrap', method='pchip');
C_Mt5l20 = interp1([0; trim5load20(:,1)]./sqrt(g*b), [0; trim5load20(:,3)]./(w*b^4), C_V, extrap='extrap', method='pchip');
C_Mt7l20 = interp1([0; trim7load20(:,1)]./sqrt(g*b), [0; trim7load20(:,3)]./(w*b^4), C_V, extrap='extrap', method='pchip');
C_Mt9l20 = interp1([0; trim9load20(:,1)]./sqrt(g*b), [0; trim9load20(:,3)]./(w*b^4), C_V, extrap='extrap', method='pchip');

%% Plot C_R a.f.o. C_V
%plot(trim2load5(:,1)./sqrt(g*b), trim2load5(:,2) ./ (w*b^3));
%figure;
%% Plot C_V v.s. C_M
%plot(trim2load10(:,1)./sqrt(g*b), trim2load5(:,3) ./ (w*b^4));

%% Plot C_M a.f.o. C_V

close all;

%plot(C_V, C_Mt2l5, C_V, C_Mt3l5, C_V, C_Mt5l5, C_V, C_Mt7l5);
%title('Trimming moment at load 0.19')
%legend('2 deg', '3 deg', '5 deg', '7 deg');

%figure;
%plot(C_V, C_Mt2l10, C_V, C_Mt3l10, C_V, C_Mt5l10, C_V, C_Mt7l10);
%title('Trimming moment at load 0.39')
%legend('2 deg', '3 deg', '5 deg', '7 deg');

%figure;
%plot(C_V, C_Mt2l20, C_V, C_Mt3l20, C_V, C_Mt5l20, C_V, C_Mt7l20, C_V, C_Mt9l20);
%title('Trimming moment at load 0.78')
%legend('2 deg', '3 deg', '5 deg', '7 deg', '9 deg');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% C_R

%% Compute C_R for a standard set of C_V for different loads and trim angles
C_V = 0:1.0:10;
trim = 2:10;

%% Load 0.19 (5lb)
C_Rt2l5 = interp1([0; trim2load5(:,1)]./sqrt(g*b), [0; trim2load5(:,2)]./(w*b^3), C_V, extrap='extrap', method='pchip');
C_Rt3l5 = interp1([0; trim3load5(:,1)]./sqrt(g*b), [0; trim3load5(:,2)]./(w*b^3), C_V, extrap='extrap', method='pchip');
C_Rt5l5 = interp1([0; trim5load5(:,1)]./sqrt(g*b), [0; trim5load5(:,2)]./(w*b^3), C_V, extrap='extrap', method='pchip');
C_Rt7l5 = interp1([0; trim7load5(:,1)]./sqrt(g*b), [0; trim7load5(:,2)]./(w*b^3), C_V, extrap='extrap', method='pchip');

%% Load 0.39 (10lb)
C_Rt2l10 = interp1([0; trim2load10(:,1)]./sqrt(g*b), [0; trim2load10(:,2)]./(w*b^3), C_V, extrap='extrap', method='pchip');
C_Rt3l10 = interp1([0; trim3load10(:,1)]./sqrt(g*b), [0; trim3load10(:,2)]./(w*b^3), C_V, extrap='extrap', method='pchip');
C_Rt5l10 = interp1([0; trim5load10(:,1)]./sqrt(g*b), [0; trim5load10(:,2)]./(w*b^3), C_V, extrap='extrap', method='pchip');
C_Rt7l10 = interp1([0; trim7load10(:,1)]./sqrt(g*b), [0; trim7load10(:,2)]./(w*b^3), C_V, extrap='extrap', method='pchip');

%% Load 0.78 (20lb)
C_Rt2l20 = interp1([0; trim2load10(:,1)]./sqrt(g*b), [0; trim2load10(:,2)]./(w*b^3), C_V, extrap='extrap', method='pchip');
C_Rt3l20 = interp1([0; trim3load20(:,1)]./sqrt(g*b), [0; trim3load20(:,2)]./(w*b^3), C_V, extrap='extrap', method='pchip');
C_Rt5l20 = interp1([0; trim5load20(:,1)]./sqrt(g*b), [0; trim5load20(:,2)]./(w*b^3), C_V, extrap='extrap', method='pchip');
C_Rt7l20 = interp1([0; trim7load20(:,1)]./sqrt(g*b), [0; trim7load20(:,2)]./(w*b^3), C_V, extrap='extrap', method='pchip');
C_Rt9l20 = interp1([0; trim9load20(:,1)]./sqrt(g*b), [0; trim9load20(:,2)]./(w*b^3), C_V, extrap='extrap', method='pchip');

%% Plot C_R a.f.o. C_V

close all;

plot(C_V, C_Rt2l5, C_V, C_Rt3l5, C_V, C_Rt5l5, C_V, C_Rt7l5);
title('Resistance at load 0.19')
legend('2 deg', '3 deg', '5 deg', '7 deg');

figure;
plot(C_V, C_Rt2l10, C_V, C_Rt3l10, C_V, C_Rt5l10, C_V, C_Rt7l10);
title('Resistance at load 0.39')
legend('2 deg', '3 deg', '5 deg', '7 deg');

figure;
plot(C_V, C_Rt2l20, C_V, C_Rt3l20, C_V, C_Rt5l20, C_V, C_Rt7l20, C_V, C_Rt9l20);
title('Resistance at load 0.78')
legend('2 deg', '3 deg', '5 deg', '7 deg', '9 deg');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% C-class 'boat data below

b = 3.0;

%% Trim angle v.s. C_V for C-class.
best_trim_kt = [0.0     4.0;
                15.0    7.0;
                25.0   10.0;
                30.0   13.0;
                60.0   12.0;
                78.0    5.0];
best_trim = interp1([best_trim_kt(:,1)]./sqrt(g*b), [best_trim_kt(:,2)], C_V, extrap='extrap', method='pchip');

figure;
plot(C_V, best_trim);
title('C-class best trim');
